
//thermal sorting with high point


/***************************************************************************
  This is a library for the AMG88xx GridEYE 8x8 IR camera

  This sketch tries to read the pixels from the sensor

  Designed specifically to work with the Adafruit AMG88 breakout
  ----> http://www.adafruit.com/products/3538

  These sensors use I2C to communicate. The device's I2C address is 0x69

  Adafruit invests time and resources providing this open source code,
  please support Adafruit andopen-source hardware by purchasing products
  from Adafruit!

  Written by Dean Miller for Adafruit Industries.
  BSD license, all text above must be included in any redistribution
 ***************************************************************************/

#include <Servo.h>
#include <Wire.h>
#include <Adafruit_AMG88xx.h>

Adafruit_AMG88xx amg;

//float pixels[AMG88xx_PIXEL_ARRAY_SIZE];
float pixels[64];


float a=0;
    float b=0;
    float c=0;
    float d=0;
    float e=.2;//higher is less sensitivity, lower more noise

    float aa=0;//high point
    float bb=0;
    float cc=0;

    int aaa=0;//counter to read value twice
    int bbb=0;
    int cccc=0;
    int eee=0;

    int z=90;//starting point for servo
    int y=0;//modification for servo

    Servo motor;//name servo motor

void setup() {

  motor.attach(7);//servo motor on pin 7
  
    Serial.begin(9600);
    Serial.println(F("AMG88xx pixels"));

    bool status;
    
    // default settings
    status = amg.begin();
    //if (!status) {
        //Serial.println("Could not find a valid AMG88xx sensor, check wiring!");
        //while (1);
    //}
    
    Serial.println("-- Pixels Test --");

    Serial.println();

    delay(100); // let sensor boot up

    
    pinMode (7,OUTPUT);//servo output
    pinMode (2,OUTPUT);//left light
    pinMode (4,OUTPUT);//middle light
    pinMode (6,OUTPUT);//right light

    digitalWrite(2,HIGH);//turn leds on
    digitalWrite(4,HIGH);
    digitalWrite(6,HIGH);

    delay(3000);

    digitalWrite(2,LOW);
    digitalWrite(4,LOW);
    digitalWrite(6,LOW);
}


void loop() { 
    //read all the pixels
    amg.readPixels(pixels);



    digitalWrite (2,LOW);//make sure leds are off
    digitalWrite (4,LOW);
    digitalWrite (6,LOW);

    delay(10);

    
//remove comments fron this section if you want to see all values
//obtained in the arrary--suggest that you add 15 second delay
//at end of program so that things won't scroll too quickly
    

    //Serial.print("[");
    
    //for(int i=1; i<=64; i++) {
      //Serial.print(pixels[i-1]);
      //Serial.print(", ");
      //if( i%8 == 0 ) Serial.println();
   // }
    //Serial.println("]");
    //Serial.println();
    

    //delay a second
    //delay(15000);


    

    //gather values for cells 0,1,2,8,9, etc. and add together

    for (int i=0; i<=63; i=i+8) {
      d=(pixels [i]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      d=(pixels [(i+1)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      d=(pixels [(i+2)]);
      a=(a+d);
      if (d>aa) {
        aa=d;
      }

      
      }


      

      



    for (int i=3; i<=63; i=i+8) {
      d=(pixels [i]);
      b=(b+d);
      if (d>bb) {
        bb=d;
      }

      
      d=(pixels [(i+1)]);
      b=(b+d);
      if (d>bb) {
        bb=d;
      }
      
      }


  
    

    for (int i=5; i<=63; i=i+8) {
      d=(pixels [i]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }

      
      d=(pixels [(i+1)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }

      
      d=(pixels [(i+2)]);
      c=(c+d);
      if (d>cc) {
        cc=d;
      }
      
      } 

      
//obtain average value for a cell in the a,b,c grouping
      a=(a/24);
      b=(b/16);
      c=(c/24);

      //Serial.println("a");
      //Serial.println(a);
      
      //Serial.println(b);
      
      //Serial.println(c);
      

if (aa>bb && aa>cc) {
  if (aa-a>.9) {
    aaa=aaa+1;
    bbb=0;
    cccc=0;
    if (aaa==2) {
      aaa=0;
  digitalWrite (2,HIGH);//turn on left led
  delay(100);
  y=-4;//start rotating servo

  z=(z+y);
if (z<20) {
  z=20;
}

if (z>160) {
  z=160;
}

motor.write(z);
  
}
}
}

if (bb>aa && bb>cc) {
  if (bb-b>.4) {
    bbb=bbb+1;
    aaa=0;
    cccc=0;
    if (bbb==2) {
      bbb=0;

  digitalWrite (4,HIGH);
  delay(100);

  y=0;//leave servo alone
z=(z+y);
if (z<20) {
  z=20;
}

if (z>160) {
  z=160;
}

motor.write(z);
  
}
}
}

if ( (cc>aa) && (cc>bb)) {
  if (cc-c>1.2) {
    cccc=cccc+1;
    aaa=0;
    bbb=0;
    if (cccc==2) {
      cccc=0;
  digitalWrite (6,HIGH);
  delay(100);
  y=4;//rotate servo ccw

z=(z+y);
if (z<20) {
  z=20;
}

if (z>160) {
  z=160;
}

motor.write(z);
  
}
}
}

//Serial.println(aa);
//Serial.println(bb);
//Serial.println(cc);

eee=eee+1;//this insures that two readings in a row needed for output
if (eee==2) {
  eee=0;
  aaa=0;
  bbb=0;
  cccc=0;
}


a=0;
b=0;
c=0;

aa=0;
bb=0;
cc=0;

delay(100);//delay to look at array on terminal



}
         


      
    
